//+------------------------------------------------------------------+
//|                                                  VininE Game.mq4 |
//|                      Copyright  2008, Victor Nicolaev aka Vinin |
//|                                           skype: victor.nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+

//   ""    



#property copyright "Copyright  2012 Victor Nicolaev"
#property link      "vinin@mail.ru"


extern double Lots = 0.1;
extern double MaximumRisk=5.0;
extern int TP=200;
extern int SL=200;


extern int MagicNumber = 0;            
bool bstart;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()  {

   return(0);
}
int deinit() {return(0);}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   static int prevtime=0;
   if(Time[0] == prevtime)  return(0);
   prevtime = Time[0];
   
   int cmd=Signal();
   if (cmd>=OP_BUY) {      
      double _cmd=iif(cmd==OP_BUY,1,-1);
      double Price=iif(cmd==OP_BUY,Ask,Bid);
      double _TP=iif(TP>0,iif(cmd==OP_BUY,Bid,Ask)+_cmd*TP*Point,0);
      double _SL=iif(SL>0,iif(cmd==OP_BUY,Bid,Ask)-_cmd*SL*Point,0);
      color OpenCl=iif(_cmd>0,Blue,Red);
      Order_Open(Symbol(), cmd, Price, _TP, _SL,MagicNumber, OpenCl);
   }
   return(0);
}

int Order_Open(string _Symbol, int OP_CMD, double Price, double _TP, double _SL, int Magic, color Opencl){
   return(OrderSend(_Symbol, OP_CMD, getLots(), Price, 3, _SL, _TP, "", Magic, 0, Opencl));
}


int Signal(){
   int Res=-1;
   int total=OrdersTotal();
   for (int i=0;i<=total;i++) {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if (OrderSymbol()==Symbol()) {
            if (OrderMagicNumber()==MagicNumber ) {
               return(Res);
            }
         }
      }
   }
      MathSrand(TimeLocal());
   Res=MathFloor(MathRand()*2.0/32767.0);
   return(Res);
}

double iif(bool a, double b, double c){if(a) return(b);return(c);}

double getLots() {
   if (MaximumRisk>0) {
      double minlot=MarketInfo(Symbol(),MODE_MINLOT);
      double maxlot = MarketInfo(Symbol(), MODE_MAXLOT);       
      double step=MarketInfo(Symbol(),MODE_LOTSTEP);

      double lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk / 100000.0/step, 0)*step; 
      lot=MathMax(MathMin(lot,maxlot),minlot);
      
   }
   else lot=Lots;
   return(lot); 
}